*** linux-2.0.28/drivers/char/console.c	Thu Nov  7 01:25:21 1996
--- KERNEL/drivers/char/console.c	Thu Jul 31 12:02:59 1997
***************
*** 308,314 ****
  	if (i >= MAX_NR_CONSOLES)
  	  return -ENXIO;
  	if (!vc_cons[i].d) {
! 	    long p, q;
  
  	    /* prevent users from taking too much memory */
  	    if (i >= MAX_NR_USER_CONSOLES && !suser())
--- 308,314 ----
  	if (i >= MAX_NR_CONSOLES)
  	  return -ENXIO;
  	if (!vc_cons[i].d) {
! 	    long p, q, b;
  
  	    /* prevent users from taking too much memory */
  	    if (i >= MAX_NR_USER_CONSOLES && !suser())
***************
*** 325,334 ****
--- 325,342 ----
  		kfree_s((char *) q, video_screen_size);
  		return -ENOMEM;
  	    }
+ 	    b = get_free_page(GFP_KERNEL);
+ 	    if (!b) {
+ 		kfree_s((char *) p, structsize);
+ 		kfree_s((char *) q, video_screen_size);
+ 		return -ENOMEM;
+ 	    }
  
  	    vc_cons[i].d = (struct vc_data *) p;
  	    p += sizeof(struct vc_data);
  	    vt_cons[i] = (struct vt_struct *) p;
+ 	    vt_cons[i]->xmit_buf = (unsigned char *)b;
+ 	    vt_cons[i]->xmit_cnt = 0;
  	    vc_scrbuf[i] = (unsigned short *) q;
  	    vc_cons[i].d->vc_kmalloced = 1;
  	    vc_cons[i].d->vc_screenbuf_size = video_screen_size;
***************
*** 1831,1846 ****
  	return n;
  }
  
  static int con_write_room(struct tty_struct *tty)
  {
! 	if (tty->stopped)
! 		return 0;
! 	return 4096;		/* No limit, really; we're not buffering */
  }
  
  static int con_chars_in_buffer(struct tty_struct *tty)
  {
! 	return 0;		/* we're not buffering */
  }
  
  void poke_blanked_console(void)
--- 1839,1889 ----
  	return n;
  }
  
+ static void con_put_char(struct tty_struct * tty, unsigned char ch)
+ {
+ 	struct vt_struct *vt = (struct vt_struct *)tty->driver_data;
+ 	unsigned long flags;
+ 
+ 	if (!tty || !vt || !vt->xmit_buf)
+ 		return;
+ 
+ 	save_flags(flags); cli();
+ 	vt->xmit_buf[vt->xmit_cnt++] = ch;
+ 	if (vt->xmit_cnt >= CON_XMIT_SIZE) {
+ 		con_write(tty, 0, vt->xmit_buf, vt->xmit_cnt);
+ 		vt->xmit_cnt = 0;
+ 	}
+ 
+ 	restore_flags(flags);
+ }
+ 
+ static void con_flush_chars(struct tty_struct *tty)
+ {
+ 	struct vt_struct *vt = (struct vt_struct *)tty->driver_data;
+ 	unsigned long flags;
+ 
+ 	if (vt->xmit_cnt <= 0 || tty->stopped || tty->hw_stopped ||
+ 	    !vt->xmit_buf)
+ 		return;
+ 
+ 	save_flags(flags); cli();
+ 	con_write(tty, 0, vt->xmit_buf, vt->xmit_cnt);
+ 	vt->xmit_cnt = 0;
+ 	restore_flags(flags);
+ }
+ 
  static int con_write_room(struct tty_struct *tty)
  {
! 	struct vt_struct *vt = (struct vt_struct *)tty->driver_data;
! 
! 	return CON_XMIT_SIZE - vt->xmit_cnt;
  }
  
  static int con_chars_in_buffer(struct tty_struct *tty)
  {
! 	struct vt_struct *vt = (struct vt_struct *)tty->driver_data;
! 
! 	return vt->xmit_cnt;
  }
  
  void poke_blanked_console(void)
***************
*** 2016,2021 ****
--- 2059,2066 ----
  
  	console_driver.open = con_open;
  	console_driver.write = con_write;
+ 	console_driver.put_char = con_put_char;
+ 	console_driver.flush_chars = con_flush_chars;
  	console_driver.write_room = con_write_room;
  	console_driver.chars_in_buffer = con_chars_in_buffer;
  	console_driver.ioctl = vt_ioctl;
***************
*** 2053,2058 ****
--- 2098,2106 ----
  		kmem_start += sizeof(struct vc_data);
  		vt_cons[currcons] = (struct vt_struct *) kmem_start;
  		kmem_start += sizeof(struct vt_struct);
+ 		vt_cons[currcons]->xmit_buf = (unsigned char *) kmem_start;
+ 		vt_cons[currcons]->xmit_cnt = 0;
+ 		kmem_start += CON_XMIT_SIZE;
  		vc_scrbuf[currcons] = (unsigned short *) kmem_start;
  		kmem_start += video_screen_size;
  		kmalloced = 0;
*** linux-2.0.28/drivers/char/vt_kern.h	Sun Mar 24 03:35:08 1996
--- KERNEL/drivers/char/vt_kern.h	Thu Jul 31 12:02:59 1997
***************
*** 18,23 ****
--- 18,28 ----
   */
  #define BROKEN_GRAPHICS_PROGRAMS 1
  
+ /*
+  * The console transmit buffer is set to one page (is this always 4096?)
+  */
+ #define CON_XMIT_SIZE	PAGE_SIZE
+ 
  extern struct vt_struct {
  	int vc_num;				/* The console number */
  	unsigned char	vc_mode;		/* KD_TEXT, ... */
***************
*** 28,33 ****
--- 33,41 ----
  	int		vt_pid;
  	int		vt_newvt;
  	struct wait_queue *paste_wait;
+ 
+ 	unsigned char	*xmit_buf;
+ 	int		xmit_cnt;
  } *vt_cons[MAX_NR_CONSOLES];
  
  void (*kd_mksound)(unsigned int hz, unsigned int ticks);
*** linux-2.0.28/fs/ext2/super.c	Sun Jul  7 01:06:53 1996
--- KERNEL/fs/ext2/super.c	Thu Jul 31 12:02:41 1997
***************
*** 282,287 ****
--- 282,288 ----
  		else if ((sb->u.ext2_sb.s_mount_state & EXT2_ERROR_FS))
  			printk ("EXT2-fs warning: mounting fs with errors, "
  				"running e2fsck is recommended\n");
+ #ifdef OVERLYVERBOSE
  		else if (es->s_max_mnt_count >= 0 &&
  		         es->s_mnt_count >= (unsigned short) es->s_max_mnt_count)
  			printk ("EXT2-fs warning: maximal mount count reached, "
***************
*** 290,295 ****
--- 291,297 ----
  			(es->s_lastcheck + es->s_checkinterval <= CURRENT_TIME))
  			printk ("EXT2-fs warning: checktime reached, "
  				"running e2fsck is recommended\n");
+ #endif
  		es->s_state &= ~EXT2_VALID_FS;
  		if (!es->s_max_mnt_count)
  			es->s_max_mnt_count = EXT2_DFL_MAX_MNT_COUNT;
*** linux-2.0.28/fs/locks.c	Fri Sep 20 07:00:35 1996
--- KERNEL/fs/locks.c	Thu Jul 31 12:02:40 1997
***************
*** 308,314 ****
  		break;
  	case F_SHLCK :
  	case F_EXLCK :
! #if 1
  /* warn a bit for now, but don't overdo it */
  {
  	static int count = 0;
--- 308,314 ----
  		break;
  	case F_SHLCK :
  	case F_EXLCK :
! #if 0
  /* warn a bit for now, but don't overdo it */
  {
  	static int count = 0;
*** linux-2.0.28/include/asm-i386/segment.h	Tue Apr  9 00:35:29 1996
--- KERNEL/include/asm-i386/segment.h	Thu Jul 31 12:02:47 1997
***************
*** 1,8 ****
  #ifndef _ASM_SEGMENT_H
  #define _ASM_SEGMENT_H
  
! #define KERNEL_CS	0x10
! #define KERNEL_DS	0x18
  
  #define USER_CS		0x23
  #define USER_DS		0x2B
--- 1,9 ----
  #ifndef _ASM_SEGMENT_H
  #define _ASM_SEGMENT_H
  
! #define	BIOS_CS		0x08	/* selector 1 */
! #define KERNEL_CS	0x10	/* selector 2 */
! #define KERNEL_DS	0x18	/* selector 3 */
  
  #define USER_CS		0x23
  #define USER_DS		0x2B
*** linux-2.0.28/include/linux/proc_fs.h	Sun Dec  1 09:59:28 1996
--- KERNEL/include/linux/proc_fs.h	Mon Nov 24 22:59:24 1997
***************
*** 104,109 ****
--- 104,113 ----
  	PROC_NET_IP_MASQ_APP,
  	PROC_NET_STRIP_STATUS,
  	PROC_NET_STRIP_TRACE,
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 	PROC_NET_WSSOCKLOG,
+ 	PROC_NET_WSBRIDGELOG,
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
  	PROC_NET_LAST
  };
  
*** linux-2.0.28/include/linux/skbuff.h	Sun Dec  1 09:59:28 1996
--- KERNEL/include/linux/skbuff.h	Thu Jul 31 12:02:46 1997
***************
*** 112,117 ****
--- 112,119 ----
  	unsigned char 	*end;			/* End pointer					*/
  	void 		(*destructor)(struct sk_buff *);	/* Destruct function		*/
  	__u16		redirport;		/* Redirect port				*/
+ 	unsigned char	ipcatch;		/* scannable packet */
+ 	struct device	*indev;			/* incoming device */
  };
  
  #ifdef CONFIG_SKB_LARGE
*** linux-2.0.28/include/linux/sockios.h	Mon May 13 13:23:07 1996
--- KERNEL/include/linux/sockios.h	Thu Jul 31 12:02:46 1997
***************
*** 53,60 ****
--- 53,73 ----
  #define SIOCADDMULTI	0x8931		/* Multicast address lists	*/
  #define SIOCDELMULTI	0x8932
  
+ #if 0
+ /* BRYAN: turn them off for now */
  #define SIOCGIFBR	0x8940		/* Bridging support		*/
  #define SIOCSIFBR	0x8941		/* Set bridging options 	*/
+ #endif
+ 
+ /* Bridge scanning support */
+ #define SIOCGIFBR	0x8945		/* Bridging support		*/
+ #define SIOCSIFBR	0x8946		/* Set bridging options 	*/
+ #define SIOCSLISTEN	0x8947		/* Set global listening socket	*/
+ #define SIOCSCANPAIR	0x8948		/* get partner in scanned pair	*/
+ #define SIOCSDONTCARE	0x8949		/* dont scan this connection	*/
+ #define SIOCSINTERNAL	0x894a		/* internally initiated		*/
+ #define SIOCBRDEBUG	0x894b		/* enable bridge debugging	*/
+ #define SIOCBRNODEBUG	0x894c		/* disable bridge debugging	*/
  
  /* ARP cache control calls. */
  #define OLD_SIOCDARP	0x8950		/* old delete ARP table entry	*/
*** linux-2.0.28/include/linux/uio.h	Thu Jun  6 11:22:24 1996
--- KERNEL/include/linux/uio.h	Thu Jul 31 12:02:46 1997
***************
*** 14,24 ****
--- 14,27 ----
  /* A word of warning: Our uio structure will clash with the C library one (which is now obsolete). Remove the C
     library one from sys/uio.h if you have a very old library set */
  
+ #ifndef IOVEC_DEFINED
+ #define IOVEC_DEFINED
  struct iovec
  {
  	void *iov_base;		/* BSD uses caddr_t (same thing in effect) */
  	int iov_len;
  };
+ #endif
  
  #define UIO_MAXIOV	16	/* Maximum iovec's in one operation 
  				   16 matches BSD */
*** linux-2.0.28/include/net/sock.h	Sun Dec  1 10:01:21 1996
--- KERNEL/include/net/sock.h	Tue Aug  5 22:38:28 1997
***************
*** 196,201 ****
--- 196,209 ----
  	struct sock		*next;
  	struct sock		*prev; /* Doubly linked chain.. */
  	struct sock		*pair;
+ 	struct sock		*scanpair; /* bridged sock's partner */
+ 	unsigned char		scanaccepted; /* bridge socks creation state */
+ 	unsigned char		dontcare; /* bridge application does not care */
+ 	unsigned char		scanclient; /* client side of scan pair */
+ 	unsigned char		finflag; /* consumed the fin */
+ 	struct device		*scandev; /* bound to this device */
+ 	struct device		*indev; /* peer bound to this device */
+ 	unsigned char		hw_addr[6]; /* internal dest MAC (ETH_ALEN) */
  	struct sk_buff		* volatile send_head;
  	struct sk_buff		* volatile send_next;
  	struct sk_buff		* volatile send_tail;
***************
*** 385,390 ****
--- 393,399 ----
  #define TIME_DESTROY	4
  #define TIME_DONE	5	/* Used to absorb those last few packets */
  #define TIME_PROBE0	6
+ #define TIME_NEWSCAN	7	/* bridged connection starting up */
  
  /*
   *	About 10 seconds 
*** linux-2.0.28/include/net/tcp.h	Sun Dec  1 10:01:21 1996
--- KERNEL/include/net/tcp.h	Mon Nov 24 22:43:31 1997
***************
*** 56,62 ****
  				 */
  
  #define TCP_TIMEOUT_LEN	(15*60*HZ) /* should be about 15 mins		*/
! #define TCP_TIMEWAIT_LEN (60*HZ) /* how long to wait to successfully 
  				  * close the socket, about 60 seconds	*/
  #define TCP_FIN_TIMEOUT (3*60*HZ) /* BSD style FIN_WAIT2 deadlock breaker */				  
  #define TCP_ACK_TIME	(3*HZ)	/* time to delay before sending an ACK	*/
--- 56,62 ----
  				 */
  
  #define TCP_TIMEOUT_LEN	(15*60*HZ) /* should be about 15 mins		*/
! #define TCP_TIMEWAIT_LEN (10*HZ) /* how long to wait to successfully 
  				  * close the socket, about 60 seconds	*/
  #define TCP_FIN_TIMEOUT (3*60*HZ) /* BSD style FIN_WAIT2 deadlock breaker */				  
  #define TCP_ACK_TIME	(3*HZ)	/* time to delay before sending an ACK	*/
***************
*** 146,151 ****
--- 146,158 ----
  extern void tcp_send_check(struct tcphdr *th, unsigned long saddr, 
  		unsigned long daddr, int len, struct sk_buff *skb);
  
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ extern void log_sockevent(struct sock *sp, int action,
+ 		unsigned long seq1, unsigned long seq2);
+ #else
+ #define log_sockevent(sp, action, seq1, seq2)
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
+ 
  /* tcp_output.c */
  
  extern void tcp_send_probe0(struct sock *);
***************
*** 156,163 ****
  extern void tcp_send_skb(struct sock *, struct sk_buff *);
  extern void tcp_send_ack(struct sock *sk);
  extern void tcp_send_delayed_ack(struct sock *sk, int max_timeout, unsigned long timeout);
! extern void tcp_send_reset(unsigned long saddr, unsigned long daddr, struct tcphdr *th,
! 	  struct proto *prot, struct options *opt, struct device *dev, int tos, int ttl);
  
  extern void tcp_enqueue_partial(struct sk_buff *, struct sock *);
  extern struct sk_buff * tcp_dequeue_partial(struct sock *);
--- 163,171 ----
  extern void tcp_send_skb(struct sock *, struct sk_buff *);
  extern void tcp_send_ack(struct sock *sk);
  extern void tcp_send_delayed_ack(struct sock *sk, int max_timeout, unsigned long timeout);
! extern void tcp_send_reset(unsigned long saddr, unsigned long daddr,
! 	struct tcphdr *th, struct proto *prot, struct options *opt,
! 	struct device *dev, int tos, int ttl, struct sk_buff *);
  
  extern void tcp_enqueue_partial(struct sk_buff *, struct sock *);
  extern struct sk_buff * tcp_dequeue_partial(struct sock *);
***************
*** 249,254 ****
--- 257,263 ----
  
  	sk->state = state;
  
+ 	log_sockevent(sk, 11, oldstate, state);
  #ifdef STATE_TRACE
  	if(sk->debug)
  		printk("TCP sk=%p, State %s -> %s\n",sk, statename[oldstate],statename[state]);
***************
*** 265,270 ****
--- 274,280 ----
  		tcp_cache_zap();
  		/* Should be about 2 rtt's */
  		reset_timer(sk, TIME_DONE, min(sk->rtt * 2, TCP_DONE_TIME));
+ 		log_sockevent(sk, 12, sk->write_seq, sk->copied_seq);
  		/* fall through */
  	default:
  		if (oldstate==TCP_ESTABLISHED)
*** linux-2.0.28/init/version.c	Sun Nov 19 07:45:02 1995
--- KERNEL/init/version.c	Thu Jul 31 12:02:43 1997
***************
*** 26,30 ****
--- 26,34 ----
  };
  
  const char *linux_banner = 
+ #if 0
  	"Linux version " UTS_RELEASE " (" LINUX_COMPILE_BY "@"
  	LINUX_COMPILE_HOST ") (" LINUX_COMPILER ") " UTS_VERSION "\n";
+ #else
+ 	"Linux version " UTS_RELEASE " [ WEBSHIELD " UTS_VERSION " ]\n";
+ #endif
*** linux-2.0.28/kernel/sched.c	Sun Sep 15 00:34:18 1996
--- KERNEL/kernel/sched.c	Mon Nov 24 22:44:37 1997
***************
*** 402,409 ****
  	return;
  
  scheduling_in_interrupt:
! 	printk("Aiee: scheduling in interrupt %p\n",
! 		__builtin_return_address(0));
  }
  
  #ifndef __alpha__
--- 402,413 ----
  	return;
  
  scheduling_in_interrupt:
! 	printk("Aiee: scheduling in interrupt %p, %p, %p, %p, %p\n",
! 		__builtin_return_address(0),
! 		__builtin_return_address(1),
! 		__builtin_return_address(2),
! 		__builtin_return_address(3),
! 		__builtin_return_address(4));
  }
  
  #ifndef __alpha__
***************
*** 450,457 ****
  	}
  	return;
  bad:
! 	printk("wait_queue is bad (eip = %p)\n",
! 		__builtin_return_address(0));
  	printk("        q = %p\n",q);
  	printk("       *q = %p\n",*q);
  }
--- 454,464 ----
  	}
  	return;
  bad:
! 	printk("wait_queue is bad (eip = %p, %p, %p, %p)\n",
! 		__builtin_return_address(0),
! 		__builtin_return_address(1),
! 		__builtin_return_address(2),
! 		__builtin_return_address(3));
  	printk("        q = %p\n",q);
  	printk("       *q = %p\n",*q);
  }
***************
*** 476,483 ****
  	}
  	return;
  bad:
! 	printk("wait_queue is bad (eip = %p)\n",
! 		__builtin_return_address(0));
  	printk("        q = %p\n",q);
  	printk("       *q = %p\n",*q);
  }
--- 483,493 ----
  	}
  	return;
  bad:
! 	printk("wait_queue is bad (eip = %p, %p, %p, %p)\n",
! 		__builtin_return_address(0),
! 		__builtin_return_address(1),
! 		__builtin_return_address(2),
! 		__builtin_return_address(3));
  	printk("        q = %p\n",q);
  	printk("       *q = %p\n",*q);
  }
***************
*** 601,630 ****
   * and the sorting routine counts on this..
   */
  static struct timer_list timer_head = { &timer_head, &timer_head, ~0, 0, NULL };
! #define SLOW_BUT_DEBUGGING_TIMERS 0
  
  void add_timer(struct timer_list * timer)
  {
  	unsigned long flags;
  	struct timer_list *p;
  
! #if SLOW_BUT_DEBUGGING_TIMERS
  	if (timer->next || timer->prev) {
! 		printk("add_timer() called with non-zero list from %p\n",
! 			__builtin_return_address(0));
  		return;
  	}
! #endif
  	p = &timer_head;
  	save_flags(flags);
  	cli();
  	do {
  		p = p->next;
  	} while (timer->expires > p->expires);
  	timer->next = p;
  	timer->prev = p->prev;
  	p->prev = timer;
  	timer->prev->next = timer;
  	restore_flags(flags);
  }
  
--- 611,889 ----
   * and the sorting routine counts on this..
   */
  static struct timer_list timer_head = { &timer_head, &timer_head, ~0, 0, NULL };
! 
! /*
!  * Get rid of all the timer debugging overhead.
!  * Bring it all back in by turning on CONFIG_WEBSHIELD_DEBUG
!  * in the configuration file.
!  */
! #ifdef CONFIG_WEBSHIELD_DEBUG
! 
! #else /* !CONFIG_WEBSHIELD_DEBUG */
! 
! #define scan_timer_log(str, p)
! #define log_timer(action, timer, prev, next)
! #define find_timer(timer)
! 
! #endif /* CONFIG_WEBSHIELD_DEBUG */
! 
! /*
!  * Count how many timers are on the list.  This is for debugging with
!  * Shift-ScrollLock only.
!  */
! int count_timer(void)
! {
! 	unsigned long flags;
! 	struct timer_list *p;
! 	int count = 0;
! 
! 	p = &timer_head;
! 	save_flags(flags);
! 	cli();
! 	while (p->next != &timer_head) {
! 		p = p->next;
! 		count++;
! 	}
! 	restore_flags(flags);
! 	return (count);
! }
! 
! #ifdef CONFIG_WEBSHIELD_DEBUG
! /*
!  * The timer_records array is a circular queue of records that
!  * log timer-related actions.
!  * Next_record points to the next timer_record to use.
!  * Records_looped flags whether or not we have used all the records.
!  * #5000*28 = 140,000 bytes.
!  * 50000*28 = 1,400,000 bytes.	... this causes spontaneous reboots on machines.
!  */
! #define NR_TIMER_LOG 5000
! struct timer_record {
! 	struct timer_list *timer;
! 	int action;
! 	struct timer_list *next;
! 	struct timer_list *prev;
! 	unsigned int jiffies;
! 	void *bt1;
! 	void *bt2;
! 	void *bt3;
! };
! static struct timer_record timer_records[NR_TIMER_LOG];
! static int records_looped = 0;
! static int next_record = 0;
! 
! /*
!  * Log a transaction on this timer.
!  * Actions are: 1. Add
!  *		2. Delete
!  *		3. Run (effectively deletes a timer)
!  *
!  * Interrupts are already cleared, so cli() is not needed.
!  */
! void log_timer(int action, struct timer_list *timer,
! 		struct timer_list *prev, struct timer_list *next)
! {
! 	struct timer_record *rp = &timer_records[next_record];
! 
! 	if (++next_record > NR_TIMER_LOG) {
! 		next_record = 0;
! 		records_looped++;
! 	}
! 	rp->timer = timer;
! 	rp->action = action;
! 	rp->next = next;
! 	rp->prev = prev;
! 	rp->jiffies = jiffies;
! 	rp->bt1 = __builtin_return_address(1);
! 	rp->bt2 = __builtin_return_address(2);
! 	/* run_timer_list does not have a long enough stack behind it */
! 	rp->bt3 = (action == 3) ? 0 : __builtin_return_address(3);
! }
! 
! /*
!  * Report recent transactions on this timer.
!  */
! void scan_timer_log(char *str, struct timer_list *timer)
! {
! 	int restart;
! 	struct timer_record *rp, *trigger;
! 	char *action_str;
! 	int nfound = 0;
! 	unsigned int oldest = 0;
! 
! 	/*
! 	 * Search backwards from next_record-1 to 0, and then from
! 	 * NR_TIMER_LOG-1 to next_record (which is the oldest record in
! 	 * the log, and thus the next to be reused).  Do the second part
! 	 * only if we have looped through the array at least once.
! 	 */
! 	trigger = &timer_records[0];
! 	rp = &timer_records[next_record - 1]; /* most recent record */
! 	for (restart = records_looped ? 1 : 0; restart >= 0; restart--) {
! 		oldest = trigger->jiffies;
! 		while (rp > trigger) {
! 			if (rp->timer == timer) {
! 				if (!nfound)
! 					printk("%s %p history:\n", str, timer);
! 				nfound++;
! 			    if (nfound < 6) { /* reduce output */
! 				switch (rp->action) {
! 					case 1: action_str = "ADD"; break;
! 					case 2: action_str = "DELETE"; break;
! 					case 3: action_str = "RUN"; break;
! 					default: action_str = "unknown"; break;
! 				}
! 				printk("  %s at %u, %p<-p->%p from %p %p %p\n",
! 					action_str, rp->jiffies, rp->prev,
! 					rp->next, rp->bt1, rp->bt2, rp->bt3);
! 			    }
! 			}
! 			rp--;
! 		}
! 		rp = &timer_records[NR_TIMER_LOG - 1];
! 		trigger = &timer_records[next_record]; /* oldest record */
! 	}
! 	if (!nfound)
! 		printk("no history found for %s %p\n", str, timer);
! 	printk("oldest record is %u, now it is %u\n", oldest, (int) jiffies);
! }
! 
! /*
!  * Determine if a given timer is already on the timer list.
!  * Return the timer just before it to match with timer->prev.
!  *
!  * This is used as a sanity check for timers that should or
!  * should not already be on the list.
!  * Also, attempt to fix things up if I hit a null p->next. (Yikes!)
!  */
! struct timer_list *find_timer(struct timer_list * timer)
! {
! 	unsigned long flags;
! 	struct timer_list *p, *pp;
! 	int count = 0;
! 
! 	if (!timer)
! 		return (struct timer_list *)0;
! 
! 	pp = p = &timer_head;
! 	save_flags(flags);
! 	cli();
! 	do {
! 		if (p->next == timer) {
! 			if (p != timer->prev) {
! 				printk("find_timer(): timer %p found on list\n",
! 					timer);
! 				printk("  but its prev %p!=%p, %p, %p, %p\n",
! 					timer->prev, p,
! 					__builtin_return_address(0),
! 					__builtin_return_address(1),
! 					__builtin_return_address(2));
! 				scan_timer_log("lost timer", timer);
! 				scan_timer_log("lost timer prev", p);
! 			}
! 			restore_flags(flags);
! 			return p; /* found the timer, return the prev */
! 		}
! 
! 		count++;
! 		/* diagnose a panic caused by a (usually) null p->next */
! 		if (!p->next) {
! 			printk("find_timer(): %p has null p->next as #%d, "
! 				"%u > %u: at %p, %p, %p, %p\n",
! 				p, count, (int)timer->expires, (int)p->expires,
! 				__builtin_return_address(0),
! 				__builtin_return_address(1),
! 				__builtin_return_address(2),
! 				__builtin_return_address(3));
! 			printk("  prev p is %p, expires=%u jiffies=%d\n",
! 				pp, (int)pp->expires, (int)jiffies);
! 			/*
! 			 * DEBUG:
! 			 *   report my most recent transactions,
! 			 *   report who was previously responsible
! 			 *     for pointing to me,
! 			 *   include backtraces in those reports.
! 			 */
! 			scan_timer_log("null timer", p);
! 			scan_timer_log("prev timer", pp);
! 
! 			/*
! 			 * Try to recover by making a new timer list.
! 			 * The front of the list (before p) is probably
! 			 * still good.  Everything after p is lost.
! 			 * I think p is bad too because I see reports of
! 			 * p->expires=0.  Use pp (previous p) if possible.
! 			 *
! 			 * I guess I could follow timer_head.prev for the
! 			 * list tail, but that is even riskier than this.
! 			 */
! 			p = pp;
! 			timer_head.prev = p;
! 			p->next = &timer_head;
! 		}
! 		pp = p;
! 		p = p->next;
! 	} while (p != &timer_head);
! 
! 	restore_flags(flags);
! 	return (struct timer_list *)0; /* did not find timer */
! }
! #endif /* CONFIG_WEBSHIELD_DEBUG */
  
  void add_timer(struct timer_list * timer)
  {
  	unsigned long flags;
  	struct timer_list *p;
  
! #ifdef CONFIG_WEBSHIELD_DEBUG
  	if (timer->next || timer->prev) {
! 		printk("add_timer() called with non-zero list from %p, %p, %p\n",
! 			__builtin_return_address(0),
! 			__builtin_return_address(1),
! 			__builtin_return_address(2));
! 		scan_timer_log("non-zero timer", timer);
  		return;
  	}
! 
! 	/* Make sure no timer entries point to this timer (even though
! 	 * I know from above that this timer points to no others).
! 	 */
! 	if (find_timer(timer)) {
! 		printk("add_timer(): timer on list from %p, %p, %p\n",
! 			__builtin_return_address(0),
! 			__builtin_return_address(1),
! 			__builtin_return_address(2));
! 		scan_timer_log("2nd non-zero timer", timer);
! 		return;
! 	}
! #endif /* CONFIG_WEBSHIELD_DEBUG */
! 
  	p = &timer_head;
  	save_flags(flags);
  	cli();
  	do {
+ 		if (!p->next) {
+ 			printk("add_timer(): null p->next from %p, %p, %p\n",
+ 				__builtin_return_address(0),
+ 				__builtin_return_address(1),
+ 				__builtin_return_address(2));
+ 			/*
+ 			 * DEBUG:
+ 			 *   report my most recent transactions,
+ 			 *   report who was previously responsible
+ 			 *     for pointing to me,
+ 			 *   include backtraces in those reports.
+ 			 */
+ 			scan_timer_log("null timer", p);
+ 			return;
+ 		}
  		p = p->next;
  	} while (timer->expires > p->expires);
  	timer->next = p;
  	timer->prev = p->prev;
  	p->prev = timer;
  	timer->prev->next = timer;
+ 	log_timer(1, timer, timer->prev, timer->next);
  	restore_flags(flags);
  }
  
***************
*** 637,642 ****
--- 896,936 ----
  		save_flags(flags);
  		cli();
  		if ((next = timer->next) != NULL) {
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ 			if (!find_timer(timer)) {
+ 				int tcount;
+ 				char cbuf[30];
+ 				struct timer_list *t, *told;
+ 
+ 				printk("del_timer: deleting timer not really on list at %p, %p, %p\n",
+ 					__builtin_return_address(0),
+ 					__builtin_return_address(1),
+ 					__builtin_return_address(2));
+ 				scan_timer_log("lost timer", timer);
+ /* also print the history of the timer that likely caused the problem */
+ 				t = timer->prev;
+ 				told = timer;
+ 				tcount = 0;
+ 				while (t && t != &timer_head && tcount < 200) {
+ 					if (t->next != told) {
+ 					    sprintf(cbuf, "lost timer prev[%d]",
+ 						tcount + 1);
+ 					    scan_timer_log(cbuf, t);
+ 					    break;
+ 					}
+ 					told = t;
+ 					t = t->prev;
+ 					tcount++;
+ 				}
+ 				if (!t) {
+ 					sprintf(cbuf, "prev timer[%d] null",
+ 					    tcount);
+ 					scan_timer_log(cbuf, told);
+ 				} else if (t != &timer_head && t->next == told)
+ 					printk("del_timer:tcount=%d\n", tcount);
+ 			}
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
+ 			log_timer(2, timer, timer->prev, timer->next);
  			(next->prev = timer->prev)->next = next;
  			timer->next = timer->prev = NULL;
  			ret = 1;
***************
*** 654,659 ****
--- 948,954 ----
  	while ((timer = timer_head.next) != &timer_head && timer->expires <= jiffies) {
  		void (*fn)(unsigned long) = timer->function;
  		unsigned long data = timer->data;
+ 		log_timer(3, timer, timer->prev, timer->next);
  		timer->next->prev = timer->prev;
  		timer->prev->next = timer->next;
  		timer->next = timer->prev = NULL;
*** linux-2.0.28/net/Config.in	Mon Jul  8 00:21:46 1996
--- KERNEL/net/Config.in	Mon Nov 24 22:40:45 1997
***************
*** 3,8 ****
--- 3,10 ----
  #
  mainmenu_option next_comment
  comment 'Networking options'
+ comment 'WebShield debugging will affect performance'
+ bool 'WebShield debugging' CONFIG_WEBSHIELD_DEBUG
  bool 'Network firewalls' CONFIG_FIREWALL
  bool 'Network aliasing'  CONFIG_NET_ALIAS
  bool 'TCP/IP networking' CONFIG_INET
